%**************************************************************************
%   "Rtadf: Testing for Bubbles with EViews" by Caspi (2015)

%   In this program, we calculate critical values for the Generalized sup ADF
%   statistic.
% *************************************************************************

function [ tstat_max_max, gsadf_cv ] = SIM_GSADF( obs, win, rep, d, eta ,beta, flag )
   
    m=rep;
    T=obs;          
    swindow0=win;    
    r0=swindow0/T;  
    dim=T-swindow0+1;

    %% DATA GENERATING PROCESS
    RandStream.setGlobalStream( RandStream('mt19937ar','seed',1234) );
    e=randn(T,m); 
    a=d*T^(-eta);
    y=cumsum(e+a);

    %% THE GENERALIZED SUP ADF TEST
    r2=swindow0:1:T;
    r2=r2';
    rw=r2-swindow0+1;

    gsadf=ones(m,1);
    sadfs=zeros(m,dim); 

    tic;
    parfor j=1:m; 
        temp=zeros(1,dim);
        for r2=swindow0:1:T;
            dim0=r2-swindow0+1;
            rwadft=zeros(dim0,1);
            for r1=1:1:dim0; 
               rwadft(r1)= ADF_FL(y(r1:r2,j),0,flag);  % two tail 5% significant level
            end;  
            temp(r2-swindow0+1)=max(rwadft);
        end;
        sadfs(j,:)=temp; 
        gsadf(j,1)=max(temp);
    end;
    toc;

    %% SUMMUP
    tstat_max_max=gsadf;
    gsadf_cv=[NaN(swindow0-1,1);quantile(sadfs',beta,2)];
    
    %% Close parallel session
    poolobj = gcp('nocreate');
    delete(poolobj);
    
end

