%**************************************************************************
%   "Rtadf: Testing for Bubbles with EViews" by Caspi (2015)

%   In this program, we calculate critical values for the Rolling ADF
%   statistic.
% *************************************************************************

function [ tstat_max, radf_cv ] = SIM_RADF( obs, win, rep, d, eta ,beta, flag )
   
     m=rep;
    T=obs;          
    swindow0=win;   
    r0=swindow0/T;  

    %% DATA GENERATING PROCESS
    RandStream.setGlobalStream( RandStream('mt19937ar','seed',1234) );
    e=randn(T,m); 
    a=d*T^(-eta);
    y=cumsum(e+a);

    %% THE SUP ADF TEST
    radfs=zeros(T-swindow0+1,m); 
    radf=ones(m,1);

    tic;
    parfor j=1:m; 
        temp=zeros(T-swindow0+1,1);
        for i=1:1:T-swindow0+1; 
            temp(i)= ADF_FL(y(i:i+swindow0-1,j),0,flag);  
        end;
        radfs(:,j)=temp;
    end;
    toc

    %% SUMMUP
    radf(:,1)=max(radfs,[],1);
        tstat_max=radf;
    radf_cv=[NaN(swindow0-1,1); quantile(radfs,beta,2)];

    %% Close parallel session
    poolobj = gcp('nocreate');
    delete(poolobj);
    
end

