%**************************************************************************
%   "Rtadf: Testing for Bubbles with EViews" by Caspi (2015)

%   In this program, we calculate critical values for the sup ADF
%   statistic.
% *************************************************************************

function [ tstat_max, sadf_cv ] = SIM_SADF( obs, win, rep, d, eta ,beta, flag )
    
    m=rep;
    T=obs;      
    swindow0=win;     
    r0=swindow0/T;  

    %% DATA GENERATING PROCESS
    rng(12345);
    e=randn(T,m); 
    a=d*T^(-eta);
    y=cumsum(e+a);

    %% THE SUP ADF TEST

    badfs=zeros(T-swindow0+1,m); 
    sadf=ones(m,1);

    tic;
    parfor j=1:m; 
        temp=zeros(T-swindow0+1,1);
        for i=swindow0:1:T; 
            temp(i-swindow0+1)= ADF_FL(y(1:i,j),0,flag);  
        end;
        badfs(:,j)=temp;
    end;
    toc

    %% SUMMUP
    sadf(:,1)=max(badfs,[],1);
    tstat_max=sadf;
    sadf_cv=[NaN(swindow0-1,1); quantile(badfs,beta,2)];

    %% Close parallel session
    poolobj = gcp('nocreate');
    delete(poolobj);

    
end

