!debug = 0

if !debug = 0 then
	logmode +addin
endif

'check that an object exists
%type = @getthistype
if %type="NONE" then
	seterr "No object found, please open a Series/Frml object"
	stop
endif

'check that _this object is an equation
if %type<>"SERIES" and %type<>"FRML" then
	seterr "Procedure can only be run from an Series/Frml object"
	stop
endif

'check wf is not a panel
if @ispanel = 1 then
	@uiprompt("Procedure does not support panel workfiles.")
	stop
endif

'get name of series, set it to "untitled" if current series doesn't have a name.
%series= _this.@name
if @len(%series)=0 then
	%name = "Untitled"
endif
%datawfname = @wfname
%datapagename = @pagename

'smpl @all

'get sample string
%origsmpl = @pagesmpl
'get number of observations
!T = @obs({%series})
!r1 = 0.01+1.8/@sqrt(!T)
!t1 = @round(!T*!r1)
'set no bootstrap as default
!bootmeth=0

if @len(@option(1)) <> 0  then  'options were given so don't put up dialog.
	'specifies type of test
	%modellist = """1. ADF"" ""2. RADF (rolling ADF) "" ""3. SADF (PWY, 2011)""  ""4. GSADF (PSY, 2015)"""
	%models = @equaloption("model")
	if @len(%models)=0 then
		%models = "1"
	endif
	!models = @val(%models)
	%ADFspec = "const"
	!ADFspec=1
	if @hasoption("trend") then
		%ADFspec = "trend"
		!ADFspec=2
		else
			if @hasoption("none") then
				%ADFspec = "none"
				!ADFspec=3
			endif
	endif
	%BOOTspec = "none"
	!BOOTspec=3
	if @hasoption("btrend") then
		%BOOTspec = "trend"
		!BOOTspec=2
		else
			if @hasoption("bconst") then
				%BOOTspec = "const"
				!BOOTspec=1
			endif
	endif
	%win = @equaloption("win")
	if @len(%win)=0 then
		%win = @str(!t1)
	endif
	%criterionlist = """fixed"" ""aic"" ""sic"" ""hqc"" ""maic"" ""msic"" ""mhqc"""
	%criterion = @equaloption("info")
	if @len(%criterion)=0 or %criterion ="fixed" then
		!criterion=1
	else
		!criterion=0
	endif
	%maxlag = @equaloption("lag")
	if @len(%maxlag)=0 then
		%maxlag = "0"
	endif
	!maxlag = @val(%maxlag)
	%blag = @equaloption("blag")
	if @len(%blag)=0 then
		%blag = "0"
	endif
	!blag = @val(%blag)
	!sim_prog=1
	!simulate= @hasoption("sim")
	!autosim=0
	if !simulate = 1 then
		!autosim = 1 'disable simulation dialog box while in command line mode
		!sim_prog=2 'set EViews as default simulator
	endif
	!matlab=@hasoption("matlab")
	if !simulate=1 and !matlab=1 then
		!sim_prog=3
	endif
	!boot=@hasoption("boot")
	if !simulate=1 and !boot=1 then
		!sim_prog=4
	endif
	!usecurrent= @hasoption("usecurrent")
	if !usecurrent=1 then
		!sim_prog=5
	endif
	if !models=1 then
		!matlab=0
	endif
	'no. of replications
	%rep = @equaloption("rep")
	if @len(%rep)=0 then
		%rep = "1000"
	endif
	'null model parameters
	%d = @equaloption("d")
	if @len(%d)=0 then
		%d = "1"
	endif
	%eta = @equaloption("eta")
	if @len(%eta)=0 then
		%eta = "1"
	endif
	%theta = @equaloption("theta")
	if @len(%theta)=0 then
		%theta = "1"
	endif
	'significance level
	%beta = @equaloption("beta")
	if @len(%beta)=0 then
		%beta = "0.95"
	endif
	'simulation accuracy
	!Trw=@hasoption("Trw")
	'output settings
	!graph=@hasoption("graph")
	!spool=@hasoption("print")
	'bootstrap settings
	!bootmeth=@hasoption("sieve")+1
	!initval=@hasoption("firstobs")+1
endif

if @len(@option(1)) = 0  then  'no options passed in, so put up dialog

	%win = @str(!t1)
	!criterion = 1
	%criterionlist = """fixed"" ""aic"" ""sic"" ""hqc"" ""maic"" ""msic"" ""mhqc"""
	%maxlag = "0"  '@str(@round(12*(_this.@obs/100)^0.25)) 'see NG and Perron (2001)
	!models = 1
	%modellist = """1. ADF"" ""2. RADF (rolling ADF)"" ""3. SADF (PWY, 2011)""  ""4. GSADF (PSY, 2015)"""
	!graph=1
	!ADFspec=1
	%ADFspeclist = """Constant"" ""Constant and trend"" ""None"""
	!sim_prog=1
	%simlist = """none"" ""Monte Carlo (EViews)"" ""Monte Carlo (Matlab)**"" ""Bootstrap"" ""use exsting simulated output***"""
	!spool=1
	
	' GUI menu setup
	!result = @uidialog("caption","Right Tailed ADF Tests*", _
							"edit",%series,"Series name", _
							"edit",%origsmpl,"Sample", _
							"list",!models,"Choose test",%modellist, _
							"edit",%win,"Initial window size (as a fraction or no. of observations, models 2-4 only)", _
							"radio",!ADFspec,"Include in test equation",%ADFspeclist , _
							"list",!criterion,"Lag length selection criteria for unit root testing",%criterionlist , _
							"edit", %maxlag,"Number of lags (maximum for automatic selection)", _
							"radio",!sim_prog,"Critical values",%simlist , _
							"text", "**Using Matlab is only available for models 2-4 and and requires the Parallel Computing Toolbox", _
							"text", "***Make sure that the necessary objects exist within the main workfile", _
							"check",!graph, "Plot graph (models 2-4 only)", _
							"text","*Whenever this add-in used please cite as follows:", _
							"text", "Caspi, I. (forthcoming). Rtadf: Testing for Bubbles with EViews. Journal of Statistical Software." )
	if !result = -1 then
		stop
	endif
	
	'define maxlag
	!maxlag=@val(%maxlag)
	' define criterion
	%criterion = "AIC"
	if !criterion = 3 then
		%criterion = "SIC"
	endif
	if !criterion = 4 then
		%criterion = "HQC"
	endif
	if !criterion = 5 then
		%criterion = "MAIC"
	endif
	if !criterion = 6 then
		%criterion = "MSIC"
	endif
	if !criterion = 7 then
		%criterion = "MHQC"
	endif
	
	%ADFspec = "const"
	if !ADFspec = 2 then 
		%ADFspec = "trend" 
	endif 
	if !ADFspec = 3 then 
		%ADFspec = "none" 
	endif 
	
	!simulate=0
	!autosim=0
	if !sim_prog=2 or !sim_prog=3 or !sim_prog=4 then
		!simulate=1
	endif
	!matlab=0
	if !sim_prog = 3 then 
		!matlab=1 
	endif 
	
	
	'define default values for simulation parameters
	if !simulate=1 then
		%rep="1000"
		%d = "1"
		%eta = "1"
		%theta = "1"
		%beta = "0.95"
		!Trw = 1
		!BOOTspec=3
		!bootmeth=1
		%blag="0"
		!initval=1
		!autosim = 0 'prompt simulation dialog		
	endif
endif

'statistics name
%model_stat=@word(@word(%modellist,!models),2)
'define sample
%start = @word(%origsmpl,1)
%end = @word(%origsmpl,2)

smpl %start %end
frml temp = {%series}

!T = @obs({%series})
!r1=@val(%win)
if !r1<1 then
	!t1 = @round(!T*!r1)
else
	!t1=!r1
endif

'generate output table
table rtadf_output

!row=1
rtadf_output(!row,1) = "Right Tailed ADF Tests"
rtadf_output.setjust(!row,1) left
!row=!row+1
rtadf_output(!row,1) = "Sample : "+%origsmpl
!row=!row+1
rtadf_output(!row,1) = "Included observations: "+@str(!T)
!row=!row+1
rtadf_output(!row,1) = "Null hypothesis: "+%series+" has a unit root"
!row=!row+1
if !criterion = 1 then
	rtadf_output(!row,1) = "Lag Length: Fixed, lag="+%maxlag
else
	rtadf_output(!row,1) = "Lag length: Automatic - based on "+%criterion+", maxlag="+%maxlag
endif
!row=!row+1
rtadf_output(!row,1) = "Window size: "+@str(!t1)
rtadf_output.setjust(!row,1) left
!row=!row+1
%datestring = "Date: " + @datestr(@now,"MM/DD/YY") + "   Time: " + @datestr(@now,"HH:MI")
rtadf_output(!row,1) = %datestring
!temprow = !row + 1
for !i=1 to 5
	rtadf_output.setlines(!temprow,!i) +d
next
!row=!row+1
!row=!row+1
rtadf_output(!row,4) = "t-Statistic"
rtadf_output(!row,5) = "Prob.*"
!temprow = !row + 1
!row=!row+1
for !i=1 to 5
	rtadf_output.setlines(!temprow,!i) +d
next
!row=!row+1
rtadf_output.setjust(!row,1) left

equation eq
smpl @all

'ADF
if !models = 1 then
	series adf = na 'for storing full sample adf
	smpl @first %start+!t1
	!offset = @obs({%series})+@nas({%series})
	smpl %start %end
	if !criterion = 1 then
		freeze(mode=overwrite,uroot) temp.uroot(adf, {%ADFspec}, lag=!maxlag) 
	else
		freeze(mode=overwrite,uroot) temp.uroot(adf, {%ADFspec}, info={%criterion}, maxlag=!maxlag) 
	endif
	!adf_temp = @val(uroot(7,4))
	smpl %start+!t1-1 %end
	adf = !adf_temp
	rtadf_output(!row,1) = "ADF"
	rtadf_output(!row,4) = @val(uroot(7,4))
	!row=!row+1
	smpl %start %end
endif

'Rolling ADF
if !models = 2 then
	series radf = na 'for storing rolling adfs
	smpl @first %start+!t1
	!offset = @obs({%series})+@nas({%series})
	!tot_recs=!T-!t1+1
	for !j=0 to !T-!t1
		smpl %start+!j %start+!t1+!j-1
		if !criterion = 1 then
			freeze(mode=overwrite,uroot) temp.uroot(adf, {%ADFspec}, lag=!maxlag) 
		else
			freeze(mode=overwrite,uroot) temp.uroot(adf, {%ADFspec}, info={%criterion}, maxlag=!maxlag) 
		endif
		radf(!offset+!j-1) = @val(uroot(7,4))
		%perc_comp=@str(@round(100*(!j+1)/!tot_recs))
		statusline Estimating the RADF statistic ({%perc_comp}% completed)
	next
	smpl %start %end
	rtadf_output(!row,1) = "max RADF"
	rtadf_output(!row,4) = @max(radf)
	!row=!row+1
endif

'SADF
if !models = 3 then
	series sadf = na 'for storing rolling adfs
	smpl @first %start+!t1
	!offset = @obs({%series})+@nas({%series})
	!tot_recs=!T-!t1+1
	for !j=0 to !T-!t1
			smpl %start %start+!t1+!j-1
			if !criterion = 1 then
				freeze(mode=overwrite,uroot) temp.uroot(adf, {%ADFspec}, lag=!maxlag) 
			else
				freeze(mode=overwrite,uroot) temp.uroot(adf, {%ADFspec}, info={%criterion}, maxlag=!maxlag)
			endif
			sadf(!offset+!j-1) = @val(uroot(7,4))
			%perc_comp=@str(@round(100*(!j+1)/!tot_recs))
			statusline Estimating the SADF statistic ({%perc_comp}% completed)
	next
	rtadf_output(!row,1) = "SADF"
	rtadf_output(!row,4) = @max(sadf)
	!row=!row+1
endif

'GSADF
if !models = 4 then
	series gsadf = na 'for storing rolling adfs
	smpl @first %start+!t1
	!offset = @obs({%series})+@nas({%series})
	matrix(!T-!t1+1,!T-!t1+1) max_adf=-99999
	vector(!T-!t1+1) gsadf_vec
	!recs = 1
	!tot_recs = (!T-!t1+1)*(!T-!t1+2)/2
	for !j=!t1 to !T
		!dim=!j-!t1
		for !k=0 to !dim
				smpl %start+!k %start+!j-1
				if !criterion = 1 then
					freeze(mode=overwrite,uroot) temp.uroot(adf, {%ADFspec}, lag=!maxlag) 
				else
					freeze(mode=overwrite,uroot) temp.uroot(adf, {%ADFspec}, info={%criterion}, maxlag=!maxlag)
				endif
				max_adf(!k+1,!j-!t1+1) = @val(uroot(7,4))
				%perc_comp=@str(@round(100*!recs/!tot_recs))
				!recs=!recs+1
		next
		statusline Estimating the GSADF statistic ({%perc_comp}% completed)
	next 
	gsadf_vec = @cmax(max_adf)		
	for !i = 1 to !T-!t1+1
		gsadf(!offset+!i-2) = gsadf_vec(!i)
	next
	smpl %start %end
	rtadf_output(!row,1) = "GSADF"
	rtadf_output(!row,4) = @max(gsadf)
	!row=!row+1
endif

!temprow=!row-1
for !i=1 to 5
	rtadf_output.setlines(!temprow,!i) +b
next

d temp

%obs = @str(@obs({%series}))

if !sim_prog <> 1  then
	if !sim_prog=2 then
		exec rtadf\rtadfsim.prg {%obs} {%win} !models !ADFspec !autosim {%rep} {%d} {%eta} {%theta} {%beta} !Trw
	endif
	If !sim_prog=3 then
		exec rtadf\rtadfsim_matlab.prg {%obs} {%win} !models !ADFspec !autosim {%rep} {%d} {%eta} {%theta} {%beta} !Trw
	endif
	If !sim_prog=4 then
		exec rtadf\rtadfbootstrap.prg {%obs} {%win} !models !ADFspec !autosim {%rep} {%beta} !Trw {%series} {%datapagename} !BOOTspec !bootmeth {%blag} !initval
	endif
	'import simulation results to default page
	if !simulate=1 then
		%simpagename = @pagename
		pageselect {%datapagename}
		copy {%simpagename}\cv cv
		copy {%simpagename}\beta_pc
		%beta_pc = @str(beta_pc)
	endif
	'ADF
	if !models = 1 then
		'compute p_value
		if !simulate=1 then
			copy {%simpagename}\tstat adf_dist
		endif
		!p_value=0
		for !i=1 to @rows(adf_dist)
			if adf_dist(!i)>@val(uroot(7,4)) then
				!p_value=!p_value+1
			endif
		next
		!p_value=!p_value/@rows(adf_dist)
		!temprow=!row-1
		rtadf_output(!temprow,5) = !p_value
		rtadf_output.setformat(!temprow,5) f.4
		'd adf_dist
		'generate critcal values table
		rtadf_output(!row,1) = "Test critical values**:"
		rtadf_output.setjust(!row,1) left
		rtadf_output(!row,2) = "99% level"
		rtadf_output(!row,4) = cv(3,2)
		!row=!row+1
		rtadf_output(!row,2) = "95% level"
		rtadf_output(!row,4) = cv(2,2)
		!row=!row+1
		rtadf_output(!row,2) = "90% level"
		rtadf_output(!row,4) = cv(1,2)
		!row=!row+1
		!graph = 0
	endif
	'RADF
	if !models = 2 then
		'compute p_value
		if !simulate=1 then
			copy {%simpagename}\tstat_max radf_dist
		endif
		!p_value=0
		for !i=1 to @rows(radf_dist)
			if radf_dist(!i)>@max(radf) then
				!p_value=!p_value+1
			endif
		next
		!p_value=!p_value/@rows(radf_dist)
		!temprow=!row-1
		rtadf_output(!temprow,5) = !p_value
		rtadf_output.setformat(!temprow,5) f.4
		'd radf_dist
		'generate graph
		if !simulate=1 then
			copy {%simpagename}\radf_cv temp_cv
			smpl @all
			series radf_cv = na
			for !i = 1 to !T
				radf_cv(!offset+!i-1-!t1) = temp_cv(!i)
			next
			d temp_cv
		endif
		if !graph = 1 then
			smpl %start %end
			graph rtadf_graph.line radf radf_cv {%series} 
			rtadf_graph.setelem(1) legend("Rolling ADF sequence (left axis)")
			rtadf_graph.setelem(2) legend({%beta_pc}% critical value sequence (left axis))
			rtadf_graph.setelem(3) legend({%series} (right axis))
			rtadf_graph.setelem(3) axis(r)
			rtadf_graph.addtext(t) "Rolling ADF test"
			rtadf_graph.options backcolor(white) backfade(none)
		endif
		rtadf_output(!row,1) = "Test critical values**:"
		rtadf_output.setjust(!row,1) left
		rtadf_output(!row,2) = "99% level"
		rtadf_output(!row,4) = cv(3,2)
		!row=!row+1
		rtadf_output(!row,2) = "95% level"
		rtadf_output(!row,4) = cv(2,2)
		!row=!row+1
		rtadf_output(!row,2) = "90% level"
		rtadf_output(!row,4) = cv(1,2)
		!row=!row+1
	endif
	'SADF
	if !models = 3 then
		'compute p_value
		if !simulate=1 then
			copy {%simpagename}\tstat_max sadf_dist
		endif
		!p_value=0
		for !i=1 to @rows(sadf_dist)
			if sadf_dist(!i)>@max(sadf) then
				!p_value=!p_value+1
			endif
		next
		!p_value=!p_value/@rows(sadf_dist)
		!temprow=!row-1
		rtadf_output(!temprow,5) = !p_value
		rtadf_output.setformat(!temprow,5) f.4
		'd sadf_dist
		'generate graph
		if !simulate=1 then
			copy {%simpagename}\sadf_cv temp_cv
			smpl @all
			series sadf_cv = na
			for !i = 1 to !T
				sadf_cv(!offset+!i-1-!t1) = temp_cv(!i)
			next
			d temp_cv
		endif
		if !graph = 1 then
			smpl %start %end
			graph rtadf_graph.line sadf sadf_cv {%series} 
			rtadf_graph.setelem(1) legend("Forward ADF sequence (left axis)")
			rtadf_graph.setelem(2) legend({%beta_pc}% critical value sequence (left axis))
			rtadf_graph.setelem(3) legend({%series} (right axis))
			rtadf_graph.setelem(3) axis(r)
			rtadf_graph.addtext(t) "SADF test"
			rtadf_graph.options backcolor(white) backfade(none)
		endif
		'generate critical values table
		rtadf_output(!row,1) = "Test critical values**:"
		rtadf_output.setjust(!row,1) left
		rtadf_output(!row,2) = "99% level"
		rtadf_output(!row,4) = cv(3,2)
		!row=!row+1
		rtadf_output(!row,2) = "95% level"
		rtadf_output(!row,4) = cv(2,2)
		!row=!row+1
		rtadf_output(!row,2) = "90% level"
		rtadf_output(!row,4) = cv(1,2)
		!row=!row+1
	endif
	'GSADF
	if !models = 4 then
		'compute p_value
		if !simulate=1 then
			copy {%simpagename}\tstat_max_max gsadf_dist
		endif
		!p_value=0
		for !i=1 to @rows(gsadf_dist)
			if gsadf_dist(!i)>@max(gsadf) then
				!p_value=!p_value+1
			endif
		next
		!p_value=!p_value/@rows(gsadf_dist)
		!temprow=!row-1
		rtadf_output(!temprow,5) = !p_value
		rtadf_output.setformat(!temprow,5) f.4
		'd gsadf_dist
		'generate graph
		if !simulate=1 then
			copy {%simpagename}\gsadf_cv temp_cv
			smpl @all
			series gsadf_cv = na
			for !i = 1 to !T
				gsadf_cv(!offset+!i-1-!t1) = temp_cv(!i)
			next
			d temp_cv
		endif
		if !graph = 1 then
			smpl %start %end
			graph rtadf_graph.line gsadf gsadf_cv {%series} 
			rtadf_graph.setelem(1) legend("Backwards SADF sequence (left axis)")
			rtadf_graph.setelem(2) legend({%beta_pc}% critical value sequence (left axis))
			rtadf_graph.setelem(3) legend({%series} (right axis))
			rtadf_graph.setelem(3) axis(r)
			rtadf_graph.addtext(t) "GSADF test"
			rtadf_graph.options backcolor(white) backfade(none)
		endif
		rtadf_output(!row,1) = "Test critical values**:"
		rtadf_output.setjust(!row,1) left
		rtadf_output(!row,2) = "99% level"
		rtadf_output(!row,4) = cv(3,2)
		!row=!row+1
		rtadf_output(!row,2) = "95% level"
		rtadf_output(!row,4) = cv(2,2)
		!row=!row+1
		rtadf_output(!row,2) = "90% level"
		rtadf_output(!row,4) = cv(1,2)
		!row=!row+1
	endif
	'Close Simulation page  dialog
	if !simulate=1 then
		if !autosim = 0 then
			!closepg = @uiprompt("Would you like to keep the simulation page?","YN") 
			if !closepg = -1 then
				stop
			endif
			if !closepg = "2" then
				pagedelete {%simpagename}
			endif
		else 
			pagedelete {%simpagename}
		endif
	endif
	'draw table boarder line
	for !i=1 to 5
		rtadf_output.setlines(!row,!i) +d
	next
endif

!row=!row+1
rtadf_output(!row,1) = "*Right-tailed test"
rtadf_output.setjust(!row,1) left
rtadf_output.setwidth(1) 20
!row=!row+1
if !sim_prog <> 1 then
	if !sim_prog=2 then
		rtadf_output(!row,1) = "**Critical values are based on a Monte Carlo simulation (run with EVIews)"
	endif
	if !sim_prog=3 then
		rtadf_output(!row,1) = "**Critical values are based on a Monte Carlo simulation (run with Matlab)"
	endif
	if !sim_prog=4 and !bootmeth=1 then
		rtadf_output(!row,1) = "**Critical values are based on wild bootstrap (run with EVIews)"
	endif
	if !sim_prog=4 and !bootmeth=2 then
		rtadf_output(!row,1) = "**Critical values are based on sieve bootstrap (run with EVIews)"
	endif
	if !sim_prog=5 then
		rtadf_output(!row,1) = "**Critical values are based on a previously run simulation or bootstrap"
	endif
endif
!row=!row+1

'create spool with results
d rtadf_spool*
spool rtadf_spool
rtadf_spool.append rtadf_output
if !graph = 1 and !sim_prog <> 1 then
	rtadf_spool.append rtadf_graph
endif
if !graph = 1 and !sim_prog = 1  then
			smpl %start %end
			graph rtadf_graph.line {%model_stat} {%series} 
			rtadf_graph.setelem(1) legend("The test statistic sequence (left axis)")
			rtadf_graph.setelem(2) legend({%series} (right axis))
			rtadf_graph.setelem(2) axis(r)
			rtadf_graph.addtext(t) {%model_stat} test
			rtadf_graph.options backcolor(white) backfade(none)
			rtadf_spool.append rtadf_graph
endif
rtadf_spool.flatten
rtadf_spool.options -tree -titles -margins -borders
if !spool=1 then
	_this.display rtadf_spool	
endif

'cleanup
d uroot eq  rtadf_output* rtadf_spool*
if !graph = 1 then
	d rtadf_graph
endif
if !sim_prog <> 1 then
	d beta_pc*
endif


