rndseed 12345

%T = %0
%rep = %5
%runin = "0"
%r1 = %1
!model = {%2}
%modellist = """1. ADF"" ""2. RADF (rolling ADF)"" ""3. SADF (PWY, 2011)""  ""4. GSADF (PSY, 2015)"""
!ADFspec = {%3}
%ADFspeclist = """Constant"" ""Constant and trend"" ""None"""
!BOOTspec = {%10}
%BOOTspeclist = """Constant"" ""Constant and trend"" ""None"""
!dist_plot=0
!Trw={%7}
%beta = %6
%series=%8
%datapagename=%9
%lags=%12
!autosim = {%4}
%bootmetlist= """wild (Harvey et al., 2016)"" ""sieve (Gutierez, 2011)"""
!bootmeth={%11}
%initvallist= """zero"" ""first observation"""
!initval={%13}

if !autosim = 0 then
	' GUI menu setup
	!result = @uidialog("caption","Bootstrap finite sample distribution and critical values", _
							"list",!model,"A. Choose test:",%modellist, _
							"text","B. Choose bootstrap specifications:", _
							"radio",!bootmeth,"Bootstrap method",%bootmetlist , _
							"edit",%rep,"Replications", _
							"radio",!ADFspec,"Include in test equation",%ADFspeclist , _
							"edit",%r1,"Initial window size (fraction or observations)", _
							"text","C. Choose the critical values sequence's significance level:", _
							"edit",%beta,"beta", _
							"text","D. Specify the bootstrap DGP:", _
							"radio",!BOOTspec,"Include in model",%BOOTspeclist , _
							"radio",!initval,"Initial value",%initvallist , _
							"edit",%lags,"Number of lags")
	if !result = -1 then
		stop
	endif
endif

!lags=@val(%lags)
%ADFspec = "c"
if !ADFspec = 2 then 
	%ADFspec = "c @trend" 
endif 
if !ADFspec = 3 then 
	%ADFspec = "" 
endif 

%BOOTspec = ""
if !BOOTspec = 2 then 
	%BOOTspec = "c @trend" 
endif 
if !BOOTspec = 1 then 
	%BOOTspec = "c" 
endif 

!rep = @val(%rep)
!runin = 0
!T = @val(%T)
!r1= @val(%r1)
if !r1<1 then
	!t1 = @round(!T*!r1)-1
else
	!t1=!r1-1
endif
!beta = @val(%beta)

'create a new page
!totalobs = !runin+!T
pagecreate(page=simulation) u !totalobs
%simpagename = @pagename
pageselect {%simpagename}
copy {%datapagename}\{%series} y
series dy=d(y)
if !lags=0 and !BOOTspec = 3 then
	series eps=dy
	smpl 1 1
	eps=0
	smpl @all
else
	equation eq.ls dy dy(-1 to -!lags) {%BOOTspec}
	eq.makeresids eps
	if !BOOTspec=1 then
		scalar alpha_hat=c(1)
		for !i=1 to !lags
			scalar gamma_hat{!i}=c(!i+1)
		next
	endif
	if !BOOTspec=2 then
		scalar alpha_hat=c(1)
		scalar delta_hat=c(2)
		for !i=1 to !lags
			scalar gamma_hat{!i}=c(!i+2)
		next
	endif
	if !BOOTspec=3 then
		for !i=1 to !lags
			scalar gamma_hat{!i}=c(!i)
		next
	endif
	smpl @all	
endif

genr epsdm=eps-@mean(eps) 'de-mean eps
stom(epsdm,epsv)
vector(!T-!lags-1) eps_starv
sample sboot !lags+1 !T

%spec=""
for !i=1 to !lags
	%spec=%spec+"gamma_hat"+@str(!i)+"*dyb(-"+@str(!i)+")+"
next
if !BOOTspec=1 then
	%spec=%spec+"alpha_hat"
endif
if !BOOTspec=2 then
	%spec=%spec+"alpha_hat+delta_hat*@trend"
endif
'string spec=%spec

scalar beta_pc = @round(!beta*100)

'**** ADF test
if !model = 1 then
	
	vector(!rep) tstat
	series adf_cv
	table cv
	
	'create a data generating proces
	series yb
	series dyb
	series eps_star

	' begin replititions
	tic
	statusline Simulating finite sample distribution
	for !i=1 to !rep
		smpl @all		
		if !bootmeth=2 then
			'sieve bootstrap
			eps_starv=@resample(epsv)
			mtos(eps_starv,eps_star,sboot)
		else
			'wild bootstrap eps
			eps_star=eps*nrnd
		endif
		if !lags=0 and !BOOTspec=3 then
			'set first observation to x=0
			smpl 1 1
			if !initval=1 then
				yb=0
			else
				yb=y
			endif
			' set rest ot observations
			smpl 2 !T
			yb =yb(-1)+eps_star
		else
			'set first observation to x=0
			smpl 1 1
			if !initval=1 then
				yb=0
			else
				yb=y
			endif
			dyb=0
			smpl 2 2+!lags-1
			dyb=dy
			' set rest ot observations
			smpl 2+!lags !T
			dyb={%spec}+eps_star
			smpl 2 !T
			yb=yb(-1)+dyb
		endif	
		smpl !runin+1 !runin+1+!T
		if !lags=0 then
			equation eq.ls d(yb) yb(-1) {%ADFspec}
		else	
			equation eq.ls d(yb) yb(-1) {%ADFspec} dyb(-1 to -!lags)
		endif
		tstat(!i)=eq.@tstats(1)
		%perc_comp=@str(@round(100*!i/!rep))
		statusline Simulating finite sample distribution ({%perc_comp}% completed)
	next
	toc
	
	if !dist_plot=1 then 
		tstat.distplot
	endif
	
	cv(1,1) = "90%"
	cv(2,1) = "95%"
	cv(3,1) = "99%"
	cv(1,2) = @quantile(tstat, .90)
	cv(2,2) = @quantile(tstat, .95)
	cv(3,2) = @quantile(tstat, .99)
endif

'****Rolling ADF test
if !model = 2 then
	matrix( !T-!t1+1,!rep) tstat
	matrix( !T-!t1+1,!rep) tstat_cv
	vector(!rep) tstat_max
	vector temp
	series radf_cv = na
	table cv
	
	'create a data generating proces
	series yb
	series dyb
	series eps_star
	' begin replititions
	tic
	statusline Simulating finite sample distribution and seuqnece of critical values 
	for !i=1 to !rep
		smpl @all		
		if !bootmeth=2 then
			'sieve bootstrap
			eps_starv=@resample(epsv)
			mtos(eps_starv,eps_star,sboot)
		else
			'wild bootstrap eps
			eps_star=eps*nrnd
		endif
		if !lags=0 and !BOOTspec=3 then
			'set first observation to x=0
			smpl 1 1
			if !initval=1 then
				yb=0
			else
				yb=y
			endif
			' set rest ot observations
			smpl 2 !T
			yb =yb(-1)+eps_star
		else
			'set first observation to x=0
			smpl 1 1
			if !initval=1 then
				yb=0
			else
				yb=y
			endif
			dyb=0
			smpl 2 2+!lags-1
			dyb=dy
			' set rest ot observations
			smpl 2+!lags !T
			dyb={%spec}+eps_star
			smpl 2 !T
			yb=yb(-1)+dyb
		endif	
		for !j=0 to !T-!t1
			smpl !runin+1+!j !runin+1+!t1+!j-1
			if !lags=0 then
				equation eq.ls d(yb) yb(-1) {%ADFspec}
			else	
				equation eq.ls d(yb) yb(-1) {%ADFspec} dyb(-1 to -!lags)
			endif
			tstat(!j+1,!i)=eq.@tstats(1)
		next
		%perc_comp=@str(@round(100*!i/!rep))
		statusline Simulating finite sample distribution and seuqnece of critical values ({%perc_comp}% completed)
	next
	toc

	tstat_max=@cmax(tstat)
	'generate ADF critical values series
	for !j=0 to !T-!t1
		temp=@rowextract(tstat,!j+1)
		radf_cv(!runin+1+!t1-1+!j)=@quantile(temp, !beta)
	next
	
	if !dist_plot=1 then 
		tstat_max.distplot
	endif
	
	cv(1,1) = "90%"
	cv(2,1) = "95%"
	cv(3,1) = "99%"
	cv(1,2) = @quantile(tstat, .90)
	cv(2,2) = @quantile(tstat, .95)
	cv(3,2) = @quantile(tstat, .99)

endif

'**** SADF test
if !model = 3  then
	matrix( !T-!t1+1,!rep) tstat
	matrix( !T-!t1+1,!rep) tstat_cv
	vector(!rep) tstat_max
	vector temp
	series sadf_cv = na
	table cv
	
	'create a data generating proces
	series yb
	series dyb
	series eps_star
	' begin replititions
	tic
	statusline Simulating finite sample distribution and seuqnece of critical values 
	for !i=1 to !rep
		smpl @all
		if !bootmeth=2 then
			'sieve bootstrap
			eps_starv=@resample(epsv)
			mtos(eps_starv,eps_star,sboot)
		else
			'wild bootstrap eps
			eps_star=eps*nrnd
		endif
		if !lags=0 and !BOOTspec=3 then
			'set first observation to x=0
			smpl 1 1
			if !initval=1 then
				yb=0
			else
				yb=y
			endif
		     ' set rest ot observations
			smpl 2 !T
			yb =yb(-1)+eps_star
		else
			'set first observation to x=0
			smpl 1 1
			if !initval=1 then
				yb=0
			else
				yb=y
			endif
			dyb=0
			smpl 2 2+!lags-1
			dyb=dy
			' set rest ot observations
			smpl 2+!lags !T
			dyb={%spec}+eps_star
			smpl 2 !T
			yb=yb(-1)+dyb
		endif	
		for !j=0 to !T-!t1
			smpl !runin+1 !runin+1+!t1+!j-1
			if !lags=0 then
				equation eq.ls d(yb) yb(-1) {%ADFspec}
			else	
				equation eq.ls d(yb) yb(-1) {%ADFspec} dyb(-1 to -!lags)
			endif
			tstat(!j+1,!i)=eq.@tstats(1)
		next
		%perc_comp=@str(@round(100*!i/!rep))
		statusline Simulating finite sample distribution and seuqnece of critical values ({%perc_comp}% completed)
	next
	toc
	
	tstat_max=@cmax(tstat)
	'generate ADF critical values series
	for !j=0 to !T-!t1
		temp=@rowextract(tstat,!j+1)
		sadf_cv(!runin+1+!t1-1+!j)=@quantile(temp, !beta)
	next

	if !dist_plot=1 then 
		tstat_max.distplot
	endif	
	
	cv(1,1) = "90%"
	cv(2,1) = "95%"	
	cv(3,1) = "99%"
	cv(1,2) = @quantile(tstat_max, .90)
	cv(2,2) = @quantile(tstat_max, .95)
	cv(3,2) = @quantile(tstat_max, .99)

endif


'**** GSADF test
if !model = 4 then
	matrix(!T-!t1+1,!T-!t1+1) tstat
	matrix(!T-!t1+1,!T-!t1+1) tstat_cv
	matrix(!T-!t1+1,!rep) tstat_max
	matrix(!T-!t1+1,!rep) tstat_max_cv
	vector(!rep) tstat_max_max
	series gsadf_cv = na
	vector temp
	table cv
	
	'create a data generating proces
	series yb
	series dyb
	series eps_star
	' begin replititions
	tic
	statusline Simulating finite sample distribution and seuqnece of critical values 
	for !i=1 to !rep
		smpl @all
		if !bootmeth=2 then
			'sieve bootstrap
			eps_starv=@resample(epsv)
			mtos(eps_starv,eps_star,sboot)
		else
			'wild bootstrap eps
			eps_star=eps*nrnd
		endif
		if !lags=0 and !BOOTspec=3 then
			'set first observation to x=0
			smpl 1 1
			if !initval=1 then
				yb=0
			else
				yb=y
			endif
			' set rest ot observations
			smpl 2 !T
			yb =yb(-1)+eps_star
		else
			'set first observation to x=0
			smpl 1 1
			if !initval=1 then
				yb=0
			else
				yb=y
			endif
			dyb=0
			smpl 2 2+!lags-1
			dyb=dy
			' set rest ot observations
			smpl 2+!lags !T
			dyb={%spec}+eps_star
			smpl 2 !T
			yb=yb(-1)+dyb
		endif	
		'initialize the matrix that holds sadf
		tstat = -99999
		for !j=!t1 to !T
			!dim=!j-!t1
			for !k=0 to !dim
				smpl !runin+1+!k !runin+1+!j-1
				if !lags=0 then
					equation eq.ls d(yb) yb(-1) {%ADFspec}
				else	
					equation eq.ls d(yb) yb(-1) {%ADFspec} dyb(-1 to -!lags)
				endif
				tstat(!k+1,!j-!t1+1)=eq.@tstats(1)
			next
		next
		colplace(tstat_max,@cmax(tstat),!i)
		%perc_comp=@str(@round(100*!i/!rep))
		statusline Simulating finite sample distribution and seuqnece of critical values ({%perc_comp}% completed)
	next
	toc
	
	tstat_max_max=@cmax(tstat_max)
	'generate BSADF critical values series
	for !j=0 to !T-!t1
		temp=@rowextract(tstat_max,!j+1)
		gsadf_cv(!runin+1+!t1-1+!j)=@quantile(temp, !beta)
	next
	
	if !dist_plot=1 then 
		tstat_max_max.distplot
	endif
	
	cv(1,1) = "90%"
	cv(2,1) = "95%"
	cv(3,1) = "99%"
	cv(1,2) = @quantile(tstat_max_max, .90)
	cv(2,2) = @quantile(tstat_max_max, .95)
	cv(3,2) = @quantile(tstat_max_max, .99)
	
endif


