%T = %0
%rep = %5
%runin = "0"
%r1 = %1
%d = %6
%eta = %7
%theta = %8
!model = {%2}
%modellist = """1. ADF"" ""2. RADF (rolling ADF)"" ""3. SADF (PWY, 2011)""  ""4. GSADF (PSY, 2015)"""
!ADFspec = {%3}
%ADFspeclist = """Constant"" ""Constant and trend"" ""None"""
!dist_plot=0
!Trw={%10}
%beta = %9

!autosim = {%4}

if !autosim = 0 then
	' GUI menu setup
	!result = @uidialog("caption","Simulate finite sample distribution and critical values (via Matlab)", _
							"list",!model,"A. Choose test:",%modellist, _
							"text","B. Choose simulation specifications:", _
							"edit",%T,"Sample size (T)", _
							"edit",%rep,"Replications", _
							"radio",!ADFspec,"Include in test equation",%ADFspeclist , _
							"edit",%r1,"Initial window size (fraction or observations)", _
							"text","C. Choose the critical values sequence's significance level:", _
							"edit",%beta,"beta", _
							"text","D. Choose the parameters for the null model:", _
							"text","x(t) = d*T^(-eta)+x(t-1)+e(t)", _
							"edit",%d,"d",2, _
							"edit",%eta,"eta", _
							"check",!Trw,"Use accurate sample size for the CV sequence (T*r_w instead of T)")
							'"check",!dist_plot,"t-stat distribution plot")
	if !result = -1 then
		stop
	endif
endif

%ADFspec = "c"
if !ADFspec = 2 then 
	%ADFspec = "c @trend" 
endif 
if !ADFspec = 3 then 
	%ADFspec = "" 
endif 


'create a new page
pagecreate(page=simulation) u 100

scalar rep = @val(%rep)
scalar runin = @val(%runin)
scalar T = @val(%T)
scalar r1= @val(%r1)
if r1<1 then
	scalar t1 = @round(T*r1)
else
	scalar t1=r1
endif
scalar delta = @val(%d)
scalar eta = @val(%eta)
scalar theta = @val(%theta)
scalar beta = @val(%beta)
scalar beta_pc = @round(beta*100)
scalar adfspec = !ADFspec

comtimeout(0)
xopen(m,nolog)
'input
xput rep
xput(name=T) T
xput t1
xput delta
xput eta
xput theta
xput beta
xput adfspec

'execute
%addinspath="cd('"+@addinspath+"\RTadf\Matlab\')"
xrun %addinspath
tic
if !model=2 then
	xrun "[tstat_max radf_cv]=SIM_RADF(T,t1,rep,delta,eta,beta,adfspec);"
	xget radf_cv
	xget tstat_max
endif
if !model=3 then
	xrun "[tstat_max sadf_cv]=SIM_SADF(T,t1,rep,delta,eta,beta,adfspec);"
	xget sadf_cv
	xget tstat_max
endif
if !model=4 then
	xrun "[tstat_max_max gsadf_cv]=SIM_GSADF(T,t1,rep,delta,eta,beta,adfspec);"
	xget gsadf_cv
	xget tstat_max_max
endif
toc
'fetch


xclose

table cv
cv(1,1) = "90%"
cv(2,1) = "95%"	
cv(3,1) = "99%"
if !model=2 or !model=3 then
	cv(1,2) = @quantile(tstat_max, .90)
	cv(2,2) = @quantile(tstat_max, .95)
	cv(3,2) = @quantile(tstat_max, .99)
endif
if !model=4 then
	cv(1,2) = @quantile(tstat_max_max, .90)
	cv(2,2) = @quantile(tstat_max_max, .95)
	cv(3,2) = @quantile(tstat_max_max, .99)
endif


